;
;   AVRVM, a virtual machine which emulates an Atmel AVR CPU.
;   Copyright (C) 2010  Joakim Soderlund
; 
;   This program is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;   (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
; 
;   You should have received a copy of the GNU General Public License
;   along with this program.  If not, see <http://www.gnu.org/licenses/>.
;

.include "m16def.inc"

.org 0x00
rjmp Main

.org 0x30
Main:

ldi R16, HIGH(RAMEND)
out SPH, R16
ldi R16, LOW(RAMEND)
out SPL, R16

rcall Subroutine 

push R18
pop R18

andi R18, 0b10000000

rjmp EXIT


; Subroutine test.
Subroutine:
	ldi R17, 0b10000000
	and R17, R16
	nop
	in R16, SPL
	in R18, SREG
	ret


; This way out!
EXIT:

